Subject: transparent UDP proxy

From: Michel Lespinasse <[email-masked]>
Date: Tue, 18 Mar 2008 04:59:45 -0700

Hi,

After redirecting UDP connections to a local port with netfilter (DNAT),
I'm trying to figure out what the original intended destination was.

For TCP sockets, I could just use the SO_ORIGINAL_DST socket option,
but that does not work with UDP (I tried, with a 2.6.22.19 kernel)

I also tried using recvmsg and looking for an IP_PKTINFO control message
as outlined in
http://lists.cistron.nl/pipermail/freeradius-users/2002-March/005600.html
but that did not work either (no anciliary data was ever received).

Is there any way to figure out the original destination IP of a NATed
UDP packet ?

Thanks,

-- 
Michel Lespinasse